"""
Multivariate polynomial.
"""

import operator

import arith

from element import Element
from coerce import bin_op

import integer

import polylist_fcns

class MPolynomial(Element):
    pass

class MPolynomial_polylist(MPolynomial):
    def __init__(self, parent, x):
        Element.__init__(self, parent)
        self.__polylist = polylist_fcns.PolyList(x, parent._monomial_order_function())

    def __repr__(self):
        #return self.__polylist.__repr__()
        return str(self.__polylist)

    def __add__(self, right):
        if not isinstance(right, MPolynomial_polylist) or self.parent() != right.parent():
            return bin_op(self, right, operator.add)
        return MPolynomial_polylist(self.parent(), self.__polylist + right.__polylist)

    def __sub__(self, right):
        return self + (-1)*right
        #if not isinstance(right, MPolynomial_polylist) or self.parent() != right.parent():
        #    return bin_op(self, right, operator.sub)
        #return MPolynomial_polylist(self.parent(), self.__polylist - right.__polylist)

    def __mul__(self, right):
        if not isinstance(right, MPolynomial_polylist) or self.parent() != right.parent():
            return bin_op(self, right, operator.mul)
        return MPolynomial_polylist(self.parent(), self.__polylist * right.__polylist)

    def __div__(self, right):
        if not isinstance(right, MPolynomial_polylist) or self.parent() != right.parent():
            return bin_op(self, right, operator.div)
        return MPolynomial_polylist(self.parent(), self.__polylist / right.__polylist)

    def __pow__(self, n):
        if not isinstance(n, (int, integer.Integer)):
            raise TypeError, "The exponent (n=%s) must be an integer."%n
        return arith.generic_power(self, n)
